// %flair:license{
// This file is part of the Flair framework distributed under the
// CECILL-C License, Version 1.0.
// %flair:license}
#ifndef DATAREMOTE_H
#define DATAREMOTE_H

#include <stdint.h>
#include "XmlWidget.h"
#include <QPoint>

class QMenu;
class QAction;

class DataRemote : public XmlWidget {
public:
  DataRemote(QString name, QString type, XmlWidget *parent, bool enabled,
             uint16_t period, uint16_t nb_buffering=1);
  ~DataRemote();
  uint16_t RefreshRate_ms(void);
  bool IsEnabled(void);
  int ReceiveSize(void);
  virtual void BufEvent(char **buf, int *buf_size, uint16_t period,uint16_t nb_buffering, bool big_endian) = 0;
  void appendmenu(QMenu *menu);
  QAction *execmenu(QWidget *parent, QMenu *menu, QPoint point);

protected:
  bool auto_refresh;
  bool is_logging;
  double refresh_rate; // en s
  int receivesize;
  uint16_t nb_buffering;

  void XmlSetup(QDomElement *dom);

private:
  void SendPeriod(uint16_t period, bool auto_refresh);
  void SendNbBuffering(uint16_t nb_buffering);
  QAction *SetAutoRefresh, *setRefreshRate,*setNbBuffering;
  //QAction **log;//todo implement this feature (log directly in gcs, in case of uav program crash)
};

#endif // DATAREMOTE_H
